//var wtd = 25;
//var htd = 25;

//var cols = 25;
//var rows = 13;

var dx = 0;//11;
var dy = 0;//16;

var ch = rows*(htd+1)-1;//777;
var cw = cols*(wtd+1)-1;//1218;
var is_overlap=0;

var ind_list=new Array();
var add_beds=new Array();

var ID=1;
var MoveMode=false;

if (!Array.prototype.indexOf)
{
  Array.prototype.indexOf = function(elt /*, from*/)
  {
    var len = this.length;

    var from = Number(arguments[1]) || 0;
    from = (from < 0)
         ? Math.ceil(from)
         : Math.floor(from);
    if (from < 0)
      from += len;

    for (; from < len; from++)
    {
      if (from in this &&
          this[from] === elt)
        return from;
    }
    return -1;
  };
}

function fixEvent(e) {
    e = e || window.event
    if ( e.pageX == null && e.clientX != null ) {
        var html = document.documentElement
        var body = document.body
        e.pageX = e.clientX + (html && html.scrollLeft || body && body.scrollLeft || 0) - (html.clientLeft || 0)
        e.pageY = e.clientY + (html && html.scrollTop || body && body.scrollTop || 0) - (html.clientTop || 0)
    }
    if (!e.which && e.button) {
        e.which = e.button & 1 ? 1 : ( e.button & 2 ? 3 : ( e.button & 4 ? 2 : 0 ) )
    }
 
    return e
}
function getAbsolutePos(el)
{
   var r = { x: el.offsetLeft, y: el.offsetTop };
   if (el.offsetParent)
   {
       var tmp = getAbsolutePos(el.offsetParent);
       r.x += tmp.x;
       r.y += tmp.y;
   }
   return r;
}
var getMousePosition = function(e){
	if (e.pageX || e.pageY) {
		var posx = e.pageX;
		var posy = e.pageY;
	}
	else if (e.clientX || e.clientY) {
		var posx = e.clientX
		var posy = e.clientY
	}
	return { 'x': posx, 'y': posy };
};

var offset_snap_grip = function(grid, size) {
	var limit = grid / 2;
	if ((size % grid) > limit) {
		return grid-(size % grid);
	} else {
		return -size % grid;
	}
}

var startSelect = false;
var startPoint = {'x': 0,'y': 0}, endPoint = {'x': 0,'y': 0},startIndex = {'x': 0,'y': 0};


function updateBlockColor(index,id)
{
  var color = $("#rm" + index).find("td.first_cell").css("background-color");
  $("#" + id).css("background-color",color);
    
}

 function clearSelected()
 {
     $(".selected").hide();
 }
 
 function getIndexes(e)
 {
      var mousePos = getMousePosition(e);
  		var ElemX = mousePos.x - $("#parent_container").attr("offsetLeft") - $("#info_panel_container").attr("offsetLeft");
  		var ElemY = mousePos.y - $("#parent_container").attr("offsetTop") - $("#info_panel_container").attr("offsetTop") + $("#info_panel_container").attr("scrollTop");
  		
  		if(ElemX <= 0)ElemX = 1;if(ElemY <= 0) ElemY = 1;

  		var ElemXCorrF = Math.ceil((ElemX)/wtd) - 1;
  		var ElemYCorrF = Math.ceil(ElemY/htd) - 1;


  		var ElemXCorr = Math.ceil((ElemX - ElemXCorrF)/wtd) - 1;
  		var ElemYCorr = Math.ceil((ElemY - ElemYCorrF)/htd) - 1;

  		posMLR = getAbsolutePos(document.getElementById("table_container"));
     
                p_x = Math.ceil(((ElemXCorr * wtd + ElemXCorr)*(wtd-1))/(wtd*wtd)) + 1;
  		p_y = Math.ceil(((ElemYCorr * htd + ElemYCorr)*(htd-1))/(htd*htd)) + 1;  
     
     return {'x': p_x, 'y': p_y};
 }
 
$(function() {
    $('.disableSelection').disableTextSelect();
    $("#table_container").css("width",cw);
 	$("#table_container").css("height",ch);
 	
    $("#parent_container").css("width",cw);
 	$("#parent_container").css("height",ch);  	

 	$(".half_block").css("opacity",0.3); 
        
    clearSelected(); 
    
    $('#table_container').bind("mousedown", function (e) {
        clearSelected();
        startSelect = true;

        startIndex = getIndexes(e);

        startPoint.x = (startIndex.x - 1) * wtd + startIndex.x - 2;
        startPoint.y = (startIndex.y - 1) * htd + startIndex.y - 2;
        endPoint.x = startPoint.x + wtd;
        endPoint.y = startPoint.y + htd;

        $(".selected").show();
        $(".selected").css("width", wtd);
        $(".selected").css("height", htd);
        $(".selected").css("left", startPoint.x);
        $(".selected").css("top", startPoint.y);
    }); 

    $('#table_container').bind("mouseup", function (e) {
        clearSelected();

        if (startSelect)
            addElemToDiv($("#parent_container"), e);

        startSelect = false;
    });	
   
    $('#table_container').bind("mousemove", function (e) {
        e = fixEvent(e);

        var indexes = getIndexes(e);

        $('#vert_block1').css("left", (indexes.x - 1) * wtd + indexes.x - 2);
        $('#vert_block2').css("left", indexes.x * wtd + indexes.x - 1);

        $('#hor_block1').css("top", (indexes.y - 1) * htd + indexes.y - 2);
        $('#hor_block2').css("top", indexes.y * htd + indexes.y - 1);

        $('#vert_block1').show();
        $('#vert_block2').show();
        $('#hor_block1').show();
        $('#hor_block2').show();

        if (startSelect){
            if (!e.which)
                return;     

            endPoint.x = indexes.x * wtd + indexes.x - 1;
            endPoint.y = indexes.y * htd + indexes.y - 1;

            var w = endPoint.x - startPoint.x,
                    h = endPoint.y - startPoint.y;

            $(".selected").css("width", w);
            $(".selected").css("height", h);
        }

    });

       
    $('#table_container').bind("mouseout", function (e) {
        $('#vert_block1').hide();
        $('#vert_block2').hide();
        $('#hor_block1').hide();
        $('#hor_block2').hide();
    });
	
	$(".first_cell span").bind("click",function(e){
	 $(this).toggleClass("minus");
	 block=$(this).parent().find("ul"); 
	 block.toggle();
	 //block_top=(block.parent("td").parent("tr").attr("id").substring(2)-1)*26;
	 
	 room_id=$(this).parent().parent().parent().attr("rel");
	 arr_ind=ind_list.indexOf(room_id);

	 $(".b"+room_id).toggle();

	 block_top=(arr_ind-1)*(htd+1);
	 
	 if (block.css("display")=="block") {
	 	bids=Array ();
		block.find("li").each(function (index,elem) {	
		 //bids[index]="b"+$(elem).attr("rel");
		 ind_list.splice(arr_ind+1+index,0,"b"+$(elem).attr("rel"));
 		});	 	
	 	//ind_list.splice(arr_ind+1,0,bids);
	 	//alert(ind_list);
	 	$("#table_container").height($("#table_container").height()+(htd+1)*block.attr("rel"));
	 	$(".r"+room_id).height((htd+1)*block.attr("rel")+htd);
	 	
	 	ch+=(htd+1)*block.attr("rel");
	 	$("#parent_container .jqDnR").each(function (index,elem) {
	    	el_top=parseInt($(elem).css("top"));
        	if (el_top>block_top && !$(elem).hasClass(".b"+room_id))
          		$(elem).css("top",el_top+(htd+1)*block.attr("rel"));
      	});	 	
	 }	
	 else {	
	 	ind_list.splice(arr_ind+1,block.attr("rel")); 
	 	//alert(ind_list);
	    $("#table_container").height($("#table_container").height()-(htd+1)*block.attr("rel"));
	    $(".r"+room_id).height(htd);
	    
	    ch-=(htd+1)*block.attr("rel");
	 	$("#parent_container .jqDnR").each(function (index,elem) {
	    	el_top=parseInt($(elem).css("top"));
        	if (el_top>block_top && !$(elem).hasClass(".b"+room_id)) {
        		if (el_top-(htd+1)*block.attr("rel")>0)
          		 $(elem).css("top",el_top-(htd+1)*block.attr("rel"));
          		else
          		 $(elem).css("top",-1);	
          	}	
      	});	 	    
	 }   
	 $("#parent_container").css("height",$("#table_container").height());
	}); 
	$(".info_table .room_row").each(function (index,elem) {	
		ind_list[index+1]=$(elem).attr("rel");
 	});
 	
 	$(".info_link").bind("click", function(e) {
 		room_id=$(this).parents("tr").attr("rel");
 		$("#info_room").show();
  		e = fixEvent(e);
		mousePos=getMousePosition(e);
 		$("#info_room").css("top",mousePos.y-$("#parent_container").attr("offsetTop")-$("#info_panel_container").attr("offsetTop")+$("#info_panel_container").attr("scrollTop"));

 		//$("#info_room").html(room_id);
  		$.ajax({url: "get_room_info.php", 
   	    	  cache: false, 
   		  	  beforeSend: function (XMLHttpRequest) {$("#info_room span").html("<img src='skin/images/ajax-loader.gif'>");},
   		  	  data: {r_id: room_id}, 
   		  	  success: function(response){$("#info_room span").html(response)}, 
   		  	  error: function(XMLHttpRequest, textStatus, errorThrown){$("#info_room span img").remove(); alert("Произошла ошибка. Попробуйте повторить действие."); }, 
   		  	  dataType: "html",
   		      type: "POST"
   		  });   		
 	});	
 	
 	
 	
 	$(".info_class_name").bind("click", function(e) {
 		class_id=$(this).attr("rel");
 		$("#info_room").show();

  		e = fixEvent(e);
		mousePos=getMousePosition(e);
 		$("#info_room").css("top",mousePos.y-$("#parent_container").attr("offsetTop")-$("#info_panel_container").attr("offsetTop")+$("#info_panel_container").attr("scrollTop"));

  		$.ajax({url: "get_room_info.php", 
   	    	  cache: false, 
   		  	  beforeSend: function (XMLHttpRequest) {$("#info_room span").html("<img src='skin/images/ajax-loader.gif'>");},
   		  	  data: {c_id: class_id}, 
   		  	  success: function(response){$("#info_room span").html(response)}, 
   		  	  error: function(XMLHttpRequest, textStatus, errorThrown){$("#info_room span img").remove(); alert("Произошла ошибка. Попробуйте повторить действие."); }, 
   		  	  dataType: "html",
   		      type: "POST"
   		  });   		
 	}); 		
 	
 	
 	$(".info_obj_name").bind("click", function(e) {
 		o_id=$(this).attr("rel");
 		$("#info_room").show();

  		e = fixEvent(e);
		mousePos=getMousePosition(e);
 		$("#info_room").css("top",mousePos.y-$("#parent_container").attr("offsetTop")-$("#info_panel_container").attr("offsetTop")+$("#info_panel_container").attr("scrollTop"));

  		$.ajax({url: "get_room_info.php", 
   	    	  cache: false, 
   		  	  beforeSend: function (XMLHttpRequest) {$("#info_room span").html("<img src='skin/images/ajax-loader.gif'>");},
   		  	  data: {o_id: o_id}, 
   		  	  success: function(response){$("#info_room span").html(response)}, 
   		  	  error: function(XMLHttpRequest, textStatus, errorThrown){$("#info_room span img").remove(); alert("Произошла ошибка. Попробуйте повторить действие."); }, 
   		  	  dataType: "html",
   		      type: "POST"
   		  });   		
 	});  	
 	
 	$(".close").bind("click", function(e) {
 	  $("#info_room").hide();
	});
	
	
	$(".info_room").bind("mouseover", function(e) {
		$(this).prev().show();
	});	

	$(".info_room").prev().bind("mouseleave", function(e) {
		$(this).hide();
	});	
	
	$("#order_hide").bind("click",function(e) {
	   //$(this).toggleClass("order_down");	
	   if ($("#info_panel .content").css("display")=="block") {
	   	$("#info_panel .content").hide();   
	  	$(this).css("background-position","top right");
	   }
	   else {
	   	$("#info_panel .content").show();   
	  	$(this).css("background-position","top left");	   	   
	   }	
	});	
	

	var selCell=Array(-1,-1);
	
	/*$("#parent_container").bind("mousemove", function(e) {
		e = fixEvent(e);
		
	    mousePos=getMousePosition(e);
  		ElemX=mousePos.x-$(this).attr("offsetLeft");
  		ElemY=mousePos.y-$(this).attr("offsetTop");

	    if(ElemX<=0)ElemX=1;if(ElemY<=0)ElemY=1;

  		ElemXCorrF=Math.ceil((ElemX)/wtd)-1;
  		ElemYCorrF=Math.ceil(ElemY/htd)-1;


  		ElemXCorr=Math.ceil((ElemX-ElemXCorrF)/wtd)-1;
  		ElemYCorr=Math.ceil((ElemY-ElemYCorrF)/htd)-1;

  		p_x=Math.ceil(((ElemXCorr*wtd+ElemXCorr)*(wtd-1))/(wtd*wtd));//if(p_x==0)p_x=1;
  		p_y=Math.ceil(((ElemYCorr*htd+ElemYCorr)*(htd-1))/(htd*htd))+1;//if(p_y==0)p_y=1;		
		

		$("tr.first_row td:eq("+selCell[0]+")").removeClass("sel_td");
		$("tr.first_row td:eq("+p_x+")").addClass("sel_td");
		
		$("td.first_cell:eq("+selCell[1]+")").removeClass("sel_td");
		$("td.first_cell:eq("+p_y+")").addClass("sel_td");
		
		selCell[0]=p_x;
		selCell[1]=p_y;

	});	*/
 
});

function elemsIntersecn(e,c,obj1,obj2) {
	pos=getAbsolutePos(obj2);
	x1=pos.x;
	y1=pos.y;
	x2=e.pageX;
	y2=e.pageY+$("#info_panel_container").attr("scrollTop");
	
	for (j=0;j<c;j++) {
		x3=$(obj1[j]).attr("x1");
		y3=$(obj1[j]).attr("y1");
		x4=$(obj1[j]).attr("x2");
		y4=$(obj1[j]).attr("y2");
		z=(x1<x4)&&(x2>x3)&&(y1<y4)&&(y2>y3);
		//$("#debug").html(x1+"<"+x4+" "+x2+">"+x3+" "+y1+"<"+y4+" "+y2+">"+y3+" ="+z);
		if ((x1<x4)&&(x2>x3)&&(y1<y4)&&(y2>y3)){
			$("#table_container").css("cursor","not-allowed");
			return 1;
		}
	}
	return 0;
}

function elemsIntersecnMove(e,c,obj1,obj2) {
	pos=getAbsolutePos(obj2);
	x1=pos.x;
	y1=pos.y;
	x2=pos.x+($(obj2).width());
	y2=pos.y+($(obj2).height());

	for (j=0;j<c;j++) {
		x3=$(obj1[j]).attr("x1");
		y3=$(obj1[j]).attr("y1");
		x4=$(obj1[j]).attr("x2");
		y4=$(obj1[j]).attr("y2");
		if ((x1<x4)&&(x2>x3)&&(y1<y4)&&(y2>y3)){
			$("#table_container").css("cursor","not-allowed");
			return 1;
		}
	}
	return 0;
}



function addElemToDiv(obj,e) {
  e = fixEvent(e);
  eid = ID;//$("#id").attr("value");
  eid = parseInt(eid);
  fid = eid+1;
  ID=fid;

  $(obj).append('<div id="block'+eid+'" class="jqDnR"><div class="iInfo" align="center" id="i_block'+eid+'"></div></div>');
    
  $("#info_panel form .content").prepend("<div id='info_panel_block"+eid+"' class='info_panel' rel=''></div>");
  $("#info_panel_block"+eid).bind("click",function(){
  	bl_id=$(this).attr("id").substring(11);  
  	$("#info_panel_container").scrollTop(parseInt($("#"+bl_id).css("top"))+1);
  });
  $("#order_count").html($("#info_panel .content div.info_panel").length);
      	
  $("#info_panel").show();

   $("#block"+eid).css("left",startPoint.x);
   $("#block"+eid).css("top",startPoint.y);
  
  var w = endPoint.x - startPoint.x, h = endPoint.y - startPoint.y - 1; 
    
  if(w < wtd) w = wtd; if(h < htd) h = htd;
  
  $("#block"+eid).css("width", w);
  $("#block"+eid).css("height",h); 

  
  getPrice("block"+eid,ind_list[startIndex.y],$("#dt" + startIndex.x).attr("rel"),Math.round(($("#block" + eid).width()*(wtd - 1)) / (wtd*wtd))); 
  
  //updateBlockColor(startIndex.y,"block"+eid);

  $("#block"+eid).resizer(true);
}

function getPrice(block_id,room_id,fdate,len) {
  bid=block_id.substring(5);	

  if (add_beds[bid]!=undefined)
   ArrayStr=add_beds[bid].toString();
  else
   ArrayStr="";	  

  $.ajax({url: "get_price.php", 
   	      cache: false, 
   		  beforeSend: function (XMLHttpRequest) {$("#info_panel_"+block_id).append("<img src='skin/images/ajax-loader.gif'>");},
   		  data: {r_id: room_id, date: fdate, length: len, block_id: block_id, add_beds: ArrayStr}, 
   		  success: function(response){ $("#info_panel_"+block_id).html("<div class='infoBlockClose'></div>"+response); // onclick='RemoveBlock("+bid+")'
   		  							   //$("#info_panel_"+block_id+"> div.infoBlockClose").css("border",bid+"px solid green");//css("border",bid+"px solid green");//click(function(e){RemoveBlock(bid)});
   		  							   $("#info_panel_"+block_id+"> div.infoBlockClose").click(function(){RemoveBlock($(this))});
   		  							   //$("#infoBlockClose"+bid).click(function(){alert(bid+"!")});
   		  	  						 }, 
   		  error: function(XMLHttpRequest, textStatus, errorThrown){$("#info_panel_"+block_id+" img").remove(); alert("Произошла ошибка. Попробуйте повторить действие."); }, 
   		  dataType: "html",
   		  type: "POST"
   		 });  
	
}	

function RemoveBlock(el) {
 bl_id=el.parent().attr("id").substring(11);	

 $("#"+bl_id).remove();
 el.parent().remove();
 //$("#info_panel_block"+id).remove();
 $("#order_count").html($("#info_panel .content div.info_panel").length);
 if ($("#info_panel .content div").length==0)
 	 $("#info_panel").hide(); 
}	

function adBed(id,room_id,block_id) {
  bid=block_id.substring(5);	
  if (add_beds[bid]==undefined)
  	add_beds[bid]=Array();
    	
  if ($("#"+id).is(':checked'))
  	add_beds[bid].push($("#"+id).val());  
  else { 
  	add_beds[bid].splice(add_beds[bid].indexOf($("#"+id).val()),1); 
  }	  
  
  
  updateBlockPosition(block_id);
}	

function updateBlockPosition(block_id) {
  var posEL=getAbsolutePos(document.getElementById(block_id));

	
  p_x=Math.ceil(((posEL.x-posMLR.x)*(wtd-1))/(wtd*wtd))+1;
  p_y=Math.ceil(((posEL.y-posMLR.y)*(htd-1))/(htd*htd))+1;

  room_count=Math.round(($("#"+block_id).height()*(htd-1))/(htd*htd));
  if (room_count>1) {
		room_id="";
		for (ii=p_y;ii<room_count+p_y;ii++) {
			room_id+="|"+ind_list[ii];
		}	
	}		
 else
	room_id=ind_list[p_y];

 getPrice($("#"+block_id).attr("id"),room_id,$("#dt"+p_x).attr("rel"),Math.round(($("#"+block_id).width()*(wtd-1))/(wtd*wtd)));	
}	


function addStaticElems(xc,yc,hc,wc,idc) {
  wc=parseInt(wc);
  hc=parseInt(hc);
  xc=parseInt(xc)-1;
  yc=parseInt(yc)-1;
  if (isNaN(wc)) wc=0;
  if (isNaN(hc)) hc=0;
  if (isNaN(xc)) xc=0;
  if (isNaN(yc)) yc=0;
  if (xc<0) xc=0;
  if (yc<0) yc=0;
  if (wc<=0) wc=1;
  if (hc<=0) hc=1;
  var x=htd*xc;
  var y=wtd*yc;
  var w=wc*wtd;
  var h=hc*htd;
  $("#parent_container").append('<div id="textarea_static_'+idc+'" class="jqDnR" style="z-index:4;"><div class="iInfo" align="center" id="i_textarea_static_'+idc+'">w: <b>'+wc+'</b>&nbsp;&nbsp;h: <b>'+hc+'</b><br>x: <b>'+(xc+1)+'</b>&nbsp;&nbsp;y: <b>'+(yc+1)+'</b></div></div>');
  $("#textarea_static_"+idc).css("width",w+wc-1);
  $("#textarea_static_"+idc).css("height",h+hc-1);
  $("#textarea_static_"+idc).css("left",x+xc-1+dx);
  $("#textarea_static_"+idc).css("top",y+yc-1+dy);
}

jQuery.fn.resizer = function(showClose) {
  return this.each(function() {
    var me = jQuery(this);
    if (showClose) {
    me.append($('<div class="jqClose"></div>').bind('click', function(e){
    	$("#info_panel_"+$(this).parent().attr("id")).remove(); 
    	$("#order_count").html($("#info_panel .content div.info_panel").length);
    	if ($("#info_panel .content div").length==0)
    	 $("#info_panel").hide();	
    	$(this).parent().remove();
    }));
    }
    me.append(
      $('<div class="jqResize"></div>').bind('mousedown', function(e) {
		e = fixEvent(e);
		//$('#table_container').unbind("mouseup");
                
		var posMLR=getAbsolutePos(document.getElementById("table_container"));
		//width vars
        var w = me.width();
        var x = e.pageX;
		var mr = posMLR.x+cw;
		var offsetMLeft = parseInt(document.getElementById($(me).attr("id")).style['width'],10);//offsetMLeft-=wtd;
		//height vars
        var h = me.height();
        var y = e.pageY;
		var mb = posMLR.y+ch;
		var offsetMTop =  parseInt(document.getElementById($(me).attr("id")).style['height'],10);//offsetMTop-=htd;

		var TargetRectangles = new Object();
		var cntE=0;
		$(".jqDnR").each(function(i){
		if($(me).attr("id")!=$(this).attr("id")){
			TargetRectangles[cntE] = new Object();
			absPos = getAbsolutePos(this);
			TargetRectangles[cntE]["x1"] = absPos.x;
			TargetRectangles[cntE]["y1"] = absPos.y;
			TargetRectangles[cntE]["x2"] = absPos.x+$(this).width();
			TargetRectangles[cntE]["y2"] = absPos.y+$(this).height();
			cntE++;
		}
		});

		//func's
        var moveHandler = function(e) {
            
			pos=getAbsolutePos(document.getElementById($(me).attr("id")));
			$("#table_container").css("cursor","se-resize");

			var isinter=elemsIntersecn(e,cntE,TargetRectangles,document.getElementById($(me).attr("id")));
			if (isinter==0) {
				if (!(e.pageY>mb)){
					r=Math.round(me.height()/htd);if(r==1)offsetH=0;else offsetH=1;
					_height=(e.pageY-y)+offsetMTop+offset_snap_grip(htd+offsetH,(e.pageY-y)+offsetMTop)-1;
					me.height(_height);
				}
				if(me.height()<htd)me.height(htd); 

				if (!(e.pageX>mr)){
					s=Math.round(me.width()/wtd);if(s==1)offsetW=0;else offsetW=1;
					_width=(e.pageX-x)+offsetMLeft+offset_snap_grip(wtd+offsetW,(e.pageX-x)+offsetMLeft)-1;
					me.width(_width);
				}
				if(me.width()<wtd)me.width(wtd);
			}
		};

        var upHandler = function(e) {  
            
        	//if (!MoveMode)
			//$('#table_container').bind("mouseup",function(e){addElemToDiv($("#parent_container"),e)});
			$("#table_container").css("cursor","auto");
			jQuery('html').unbind('mousemove',moveHandler).unbind('mouseup',upHandler); 

			updateBlockPosition($(me).attr("id"));

		};
        jQuery('html').bind('mousemove', moveHandler).bind('mouseup', upHandler);
      })
    );
	me.append($('<div class="jqMove"></div>').bind('mousedown', function(e) {
		e = fixEvent(e);
               
		//$('#table_container').unbind("mouseup");
                
		var posMLR=getAbsolutePos(document.getElementById("table_container"));
		var mb = posMLR.y+ch;
		var mr = posMLR.x+cw;

		var offsetMLeft = document.getElementById($(me).attr("id")).offsetLeft;
		var offsetMTop = document.getElementById($(me).attr("id")).offsetTop;

		var posV= getMousePosition(e);
		var lastMouseX = posV.x;
		var lastMouseY = posV.y;
		var posEL=getAbsolutePos(document.getElementById($(me).attr("id")));
		var posELleft=$(document.getElementById($(me).attr("id"))).css("left");
		var posELtop=$(document.getElementById($(me).attr("id"))).css("top");

		var TargetRectangles = new Object();
		var cntE=0;
		$(".jqDnR:visible").each(function(i){
		if($(me).attr("id")!=$(this).attr("id")){
			TargetRectangles[cntE] = new Object();
			absPos = getAbsolutePos(this);
			TargetRectangles[cntE]["x1"] = absPos.x;
			TargetRectangles[cntE]["y1"] = absPos.y;
			TargetRectangles[cntE]["x2"] = absPos.x+$(this).width();
			TargetRectangles[cntE]["y2"] = absPos.y+$(this).height();
			cntE++;
		}
		});

		var updatePosition = function(e) {
			$("#table_container").css("cursor","move");
		var posELCurr = getAbsolutePos(document.getElementById($(me).attr("id")));
		var pos = getMousePosition(e);

		is_overlap=elemsIntersecnMove(e,cntE,TargetRectangles,document.getElementById($(me).attr("id")));

			var _left = (pos.x - lastMouseX) + offsetMLeft;
			var _top = (pos.y - lastMouseY) + offsetMTop;

			_left = _left + offset_snap_grip(wtd, _left);
			_top = _top + offset_snap_grip(htd, _top);

			shx=Math.ceil(_left/wtd);
			shy=Math.ceil(_top/htd);
			
			//$("#debug").html("_left: "+_left+" |  _top: "+_top+" |  shx: "+shx+" |  shy: "+shy);

			$(me).css("left",_left+shx-1+dx);
			//$("#info_panel").html(_top+" "+shy+" "+dy);
			$(me).css("top",_top+(shy % (htd+1)) -1+dy);
			//$(me).css("top",_top+shy-1+dy);

			var posELCurrAfter = getAbsolutePos(document.getElementById($(me).attr("id")));

			if ((posELCurrAfter.x+me.width())>(posMLR.x+cw)){
				_newLeft = (cw-wtd-1)-((Math.ceil(me.width()/(wtd+1)))-1)*(wtd+1);
				$(me).css("left",_newLeft+dx);
			}
			if ((posELCurrAfter.y+me.height())>(posMLR.y+ch)){
				_newTop = (ch-htd-1)-((Math.ceil(me.height()/(htd+1)))-1)*(htd+1);
				$(me).css("top",_newTop+dy);
			}
			if (posELCurrAfter.x<posMLR.x){
				$(me).css("left",-1+dx);
			}
			if (posELCurrAfter.y<posMLR.y){
				$(me).css("top",-1+dy);
			}                        
       
//                        var index = Math.ceil(($(me).offset().top - $("#table_container").offset().top)/htd);  
//                        updateBlockColor(index,$(me).attr("id"));
                        
		};
        var upHandler = function(e) {
                    clearSelected();                  
                    startSelect = false;
            
        	//if (!MoveMode)
		//	$('#table_container').bind("mouseup",function(e){addElemToDiv($("#parent_container"),e)});
			if (is_overlap==1){
				$(me).css("top",offsetMTop);
				$(me).css("left",offsetMLeft);
			}
			$("#table_container").css("cursor","auto");
			jQuery('html').unbind('mousemove',updatePosition).unbind('mouseup',upHandler); 
			
			updateBlockPosition($(me).attr("id"));

		};
        jQuery('html').bind('mousemove', updatePosition).bind('mouseup', upHandler);
	  })
	);
  });

}
///////////////////////////////////////////////////////////////////////////
function openWin(url) { myWin= open(url, "displayWindow", "width=980,height=700,status=no,toolbar=no,resizable=yes,scrollbars=yes,menubar=no"); } 

function googleTranslateElementInit() {
  new google.translate.TranslateElement({
    pageLanguage: 'uk',
    includedLanguages: 'en,bg,hu,it,lt,de,pl,ro,ru,sk,sl,fr,hr,cs,et'
  }, 'google_translate_element');
} 